require 'json'
require 'easy_type/encryption'

module EasyType
  module CatalogData
    include EasyType::Encryption
    #
    # Get the content of the catalog from anywhere. This is quite a hack, but it seems 
    # to work
    #
    def catalog
      #
      # This is a hack to access the catalog
      #
      return @catalog if @catalog
      catalogs = ObjectSpace.each_object(Puppet::Resource::Catalog).to_a
      raise Puppet::Error.new('No catalog found') if catalogs.empty?
      @catalog ||= catalogs.first
    end

    #
    # Get the data with the specified key from the catalog and transform
    # it back to the original data
    #
    def get_catalog_data(key)
      data_resource = catalog.resource('em_data',key)
      json_value = data_resource['data']
      JSON.parse(json_value)
    end

    #
    # Get the secured data with the specified key from the catalog and transform
    # it back to the original data
    #
    def get_secured_catalog_data(key)
      begin
        data_resource = catalog.resource('em_data',key)
        secured_value = data_resource['data']
      rescue
        Puppet.debug "Catalog data with key '#{key}', not found in catalog"
        raise Puppet::Error.new "Catalog data with key '#{key}', not found in catalog"
      end
      unsecured_json_value = decrypt(secured_value)
      JSON.parse(unsecured_json_value)
    end
  end
end