#
# See the file "LICENSE" for the full license governing this code.
#
# frozen_string_literal: true

# rubocop: disable Metrics/AbcSize
# Docs
module EasyType
  # Docs
  module Encryption
    def cipher
      @cipher ||= OpenSSL::Cipher.new('AES-128-CBC')
    end

    #
    # For now we use a standard decryption key
    #
    def encryption_key
      'zEjryBhUkwDnQAKY'
    end

    def encrypt(value)
      @cipher = nil
      cipher.encrypt
      cipher.key = encryption_key
      iv = cipher.random_iv
      encrypted = cipher.update(value.to_s) << cipher.final
      "{AES}#{Base64.encode64(iv).chop}|#{Base64.encode64(encrypted).chop}"
    end

    def decrypted_value(value)
      encrypted?(value) ? decrypt(value) : value
    end

    def decrypt(value)
      # Fetch encryption parts from value
      encrypted_string = value[5..-1]
      crypted_iv, crypted_value = encrypted_string.split('|')
      raise ArgumentError, 'invalid value for decryption' unless crypted_iv && crypted_value
      iv = Base64.decode64(crypted_iv)
      value = Base64.decode64(crypted_value)

      # Decrypt value
      @cipher = nil
      cipher.decrypt
      cipher.key = encryption_key
      cipher.iv = iv
      cipher.update(value) + cipher.final
    end

    def encrypted?(value)
      #
      # For now we only support one sort of encryption. Might change in the future
      #
      value[0..4] == '{AES}'
    end
  end
end
# rubocop: enable Metrics/AbcSize
