#
# See the file "LICENSE" for the full license governing this code.
#
# frozen_string_literal: true

require 'entitlement/entry'

module Entitlement
  #
  # This entry allows you to specfy custom ruby code to be run for checking entitlement validity
  #
  class CustomEntry < Entry
    def initialize(modules, from, to, filename_string, &validate)
      super(modules, from, to, filename_string, &validate)
    end

    def valid?(module_name, resources = nil)
      Puppet.debug 'Found a custom entitlement....'
      super
    end

    def inspect
      super
      puts 'Custom      : <some custom checks>'
    end
  end
end
