#
# See the file "LICENSE" for the full license governing this code.
#
# frozen_string_literal: true

require 'entitlement/entry'
require 'facter'

module Entitlement
  # Docs
  class SizedEntry < Entry
    def initialize(modules, from, to, filename_string, size, &proc)
      super(modules, from, to, filename_string, &proc)
      @size = size
    end

    def valid?(module_name, resources = nil)
      Puppet.debug 'Found a sized entitlement....'
      size = resources ? resources.size : nil
      super ? valid_number_of_entries?(size) : false
    end

    def inspect
      super
      puts "# of entries: #{@size}"
    end

    private

    def valid_number_of_entries?(size)
      size ? size <= @size : true
    end
  end
end
