#
# @summary Return the name of the current CIS/STIG control
#
# See the file "LICENSE" for the full license governing this code.
#
Puppet::Functions.create_function('easy_type::current_control', Puppet::Functions::InternalFunction) do
  dispatch :current_control do
    scope_param
  end

  def current_control( scope)
    module_name  = scope.to_s.scan(/\((\w+)/).flatten.first.downcase
    control_name = scope.to_s.scan(/Validators::(.*)[\[|:]/).flatten.first.downcase
    instance     = scope.to_s.scan(/\[(.*)\]/).flatten.first
    "#{module_name}::#{control_name}[#{instance}]"
  end
end
    