#
# See the file "LICENSE" for the full license governing this code.
#
# frozen_string_literal: true

newproperty(:properties) do
  include EasyType
  include EasyType::Helpers

  desc <<-DESC
    The actual properties you want the resource property to be set to.

    In the next example, you want to set the property `owner` to the value `root`
    for the file `/tmp/a.a`.

        resource_merge { 'File[/tmp/a.a]':
          properties => {
            owner => 'root,
            mode  => '0700',
          }
        }

  DESC
end
