newparam(:environment) do
  desc "An array of any additional environment variables you want to set for a
    command, such as `[ 'HOME=/root', 'MAIL=root@example.com']`.
    Note that if you use this to set PATH, it will override the `path`
    attribute. Multiple environment variables should be specified as an
    array."

  validate do |values|
    values = [values] unless values.is_a? Array
    values.each do |value|
      unless value =~ /\w+=/
        raise ArgumentError, _("Invalid environment setting '%{value}'") % { value: value }
      end
    end
  end
end
