# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newparam(:expected_value) do
  include EasyType

  desc <<-DESC
  besides string compares, `validation` can also do numeric comparisons. The `expected_value`
  can contain a comparision like this:

  ```
  expected_value => '>10',
  ```

  You can also use multiple comparisons like this:

  ```
  expected_value => ['>10','<100']
  ```

  When using the `==` operator, beware trhat all values are converted to real values. So use

  ```
  expected_value => '==10.0'
  ```

  When you use this comparison.

  To convert the output of the check to a number, use the `parse_value` parameter.
  DESC

  data_type('Optional[Variant[String[1], Array[String[1]]]]')
end
