# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newparam(:group) do
  include EasyType
  include EasyType::Validators::Name

  desc <<-DESC
    The group the check will run in.

    If none is specified, it will run as root.

        validation { ...:
          ...
          user => 'scott',
        }

  DESC
  data_type('Optional[String[1]]')
end

autorequire(:group) do
  # Autorequire group if it is specified by name
  user = self[:group]
  if group && group !~ /^\d+$/
    group
  end
end
