# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newparam(:user) do
  include EasyType
  include EasyType::Validators::Name

  desc <<-DESC
    The user the check will run in.

    If none is specified, it will run as root.

        validation { ...:
          ...
          user => 'scott',
        }

  DESC
  data_type('Optional[String[1]]')
end

autorequire(:user) do
  # Autorequire user if it is specified by name
  user = self[:user]
  if user && user !~ /^\d+$/
    user
  end
end
