# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
$LOAD_PATH.unshift(File.absolute_path("#{__dir__}/../.."))
$LOAD_PATH.unshift(File.absolute_path("#{__dir__}/../../../../easy_type/lib"))
require 'easy_type'


require 'puppet/type/validation' unless defined?(Puppet::Type::Validation)

Puppet::Type.newtype(:validation_results) do
  include EasyType

  desc <<-DESC
  This type allows you to report the results of all validations back to the puppetserver or to
  the in-control server.
  DESC

  def supported_types
    %w(Validation Ora_validation Pg_validation Db2_validation).freeze
  end

  def results
    supported_types.reduce({}) do |acc, t| 
      next acc unless Puppet::Type::const_defined?(t)

      acc.merge(Puppet::Type::const_get(t).send(:results) || {} )
    end
  end

  to_get_raw_resources do
    []
  end

  on_modify do
  end

  parameter :name
  parameter :report_interval

  property  :controls
end
